import 'package:flutter/cupertino.dart';
import 'package:flutter_adserver/ads.dart';
import 'package:flutter_adserver/controller/ad_view_controller.dart';
import 'package:get/get.dart';

class AdView extends StatefulWidget {
  final String? adSlot;
  final BoxFit? boxFit;
  const AdView({ Key? key, @required this.adSlot, @required this.boxFit}) : super(key: key);

  @override
  State<AdView> createState() => _AdViewState();
}

class _AdViewState extends State<AdView> {
  AdViewController controller = Get.put(AdViewController());

  @override
  void initState() {
    super.initState();
    controller.fetchAd(widget.adSlot);

  }

  @override
  Widget build(BuildContext context) {
    print("called for second time");

    return controller.obx(
      (state) => Image.network(state!.url!,fit: widget.boxFit ?? BoxFit.cover, loadingBuilder: (BuildContext context, Widget child,
          ImageChunkEvent? loadingProgress) {
        if (loadingProgress == null){
          controller.impression(state);
          return child;
        }else{
          return Container();
        }
      }),
      onError: (error){
        return Container();
      },
      onLoading: Container(),
      onEmpty: Container()
    );
  }

  @override
  void dispose() {
    super.dispose();
    print("dispose");
    Get.delete<AdViewController>();
  }
}
