class AdsResponse {
  String? adId;
  String? advertiser;
  int? bidPrice;
  int? clearingPrice;
  int? clearingPriceSupplyCUR;
  int? clearingPriceUSD;
  String? clickThrough;
  String? demand;
  List<Pixels>? pixels;
  String? type;
  String? url;

  AdsResponse(
      {this.adId,
        this.advertiser,
        this.bidPrice,
        this.clearingPrice,
        this.clearingPriceSupplyCUR,
        this.clearingPriceUSD,
        this.clickThrough,
        this.demand,
        this.pixels,
        this.type,
        this.url});

  AdsResponse.fromJson(Map<String, dynamic> json) {
    adId = json['adId'];
    advertiser = json['advertiser'];
    bidPrice = json['bidPrice'];
    clearingPrice = json['clearingPrice'];
    clearingPriceSupplyCUR = json['clearingPriceSupplyCUR'];
    clearingPriceUSD = json['clearingPriceUSD'];
    clickThrough = json['clickThrough'];
    demand = json['demand'];
    if (json['pixels'] != null) {
      pixels = <Pixels>[];
      json['pixels'].forEach((v) {
        pixels!.add(new Pixels.fromJson(v));
      });
    }
    type = json['type'];
    url = json['url'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['adId'] = this.adId;
    data['advertiser'] = this.advertiser;
    data['bidPrice'] = this.bidPrice;
    data['clearingPrice'] = this.clearingPrice;
    data['clearingPriceSupplyCUR'] = this.clearingPriceSupplyCUR;
    data['clearingPriceUSD'] = this.clearingPriceUSD;
    data['clickThrough'] = this.clickThrough;
    data['demand'] = this.demand;
    if (this.pixels != null) {
      data['pixels'] = this.pixels!.map((v) => v.toJson()).toList();
    }
    data['type'] = this.type;
    data['url'] = this.url;
    return data;
  }


  String impressionUrl() {
    return pixels?.firstWhere((element) => element.event!.toLowerCase() == "impression" ).url ?? "";
  }

  String? token() {
    var value = pixels?.firstWhere((element) => element.event!.toLowerCase() == "click" ).url ?? "";
    if(value.isNotEmpty){
      return Uri.parse(value).queryParameters["t"];
    }else{
      return null;
    }
  }
}

class Pixels {
  String? event;
  String? url;

  Pixels({this.event, this.url});

  Pixels.fromJson(Map<String, dynamic> json) {
    event = json['event'];
    url = json['url'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['event'] = this.event;
    data['url'] = this.url;
    return data;
  }
}
